#ifndef __IB_H__
#define __IB_H__

/* ibcnt transfer counts */
extern volatile int ibcnt;
extern volatile long ibcntl;

/* ibsta status global and values */
extern volatile int ibsta;

#define DCAS  0x0001
#define DTAS  0x0002
#define LACS  0x0004
#define TACS  0x0008
#define ATN   0x0010
#define CIC   0x0020
#define REM   0x0040
#define LOK   0x0080
#define CMPL  0x0100
#define EVENT 0x0200
#define SPOLL 0x0400
#define RQS   0x0800
#define SRQI  0x1000
#define END   0x2000
#define TIMO  0x4000
#define ERR   0x8000

/* iberr errorno global and values */
extern volatile int iberr;

#define EDVR  0
#define ECIC  1
#define ENOL  2
#define EADR  3
#define EARG  4
#define ESAC  5
#define EABO  6
#define ENEB  7
#define EDMA  8
#define EOIP  10
#define ECAP  11
#define EFSO  12
#define EBUS  14
#define ESTB  15
#define ESRQ  16
#define ETAB  20

/* minimal command set, enough to compile normal gpib code */
int ibclr(int dev);
int ibdev(int ignored, int dev, int sec_addr, int timeout_ms, int send_eoi, int eosmode);
int ibonl(int ignored, int online);
int ibeos(int ignored, int eosmode);
#define REOS  0x0400
#define XEOS  0x0800
#define BIN   0x1000
int ibeot(int ignored, int send_eoi);
int ibfind(const char *ignored);
int ibrd(int ignored, void *buf, long len);
int ibwrt(int ignored, const void *buf, long len);

/* Some Prologix / AR488 specific extensions */
int ibrdcmd(int ignored, void *buf, long len);
int ibwrtcmd(int ignored, const void *buf, long len);

#endif /* __IB_H__ */
