#ifndef __TDSROM_GPIB_H__
#define __TDSROM_GPIB_H__

#if BYTE_ORDER == LITTLE_ENDIAN
#define cpu_to_be16(_x) ((((_x) & 0xff) << 8) | (((_x) >> 8) & 0xff))
#define be16_to_cpu cpu_to_be16
#define cpu_to_be32(_x) (cpu_to_be16(((_x) >> 16) & 0xffff) | \
			 (cpu_to_be16(((_x) & 0xffff)) << 16))
#define be32_to_cpu cpu_to_be32
#else
#define cpu_to_be16
#define cpu_to_be32
#define be16_to_cpu
#define be32_to_cpu
#endif

struct cmd_hdr {
	uint8_t cmd;
	uint8_t csum;
	uint16_t len;
};

struct memory_read_cmd {
	struct cmd_hdr hdr;
	uint32_t addr;
	uint32_t len;
};

struct memory_write_cmd {
	struct cmd_hdr hdr;
	uint32_t addr;
	uint32_t len;
	uint8_t buf[1024];
};

struct branch_cmd {
	struct cmd_hdr hdr;
	uint32_t argc;
	uint32_t unk;
	uint32_t fcn;
	uint32_t arg0;
	char data[512];
};

int gpib_command(struct cmd_hdr *cmd, int len, char ret, struct cmd_hdr *hdr, uint8_t *buf, int elen);

#endif
