#include "linker_symbols.h"
#include "tds.h"

__attribute__ ((section (".data.crt")))
static long _first_run = 0x12c0ffee;

static inline uint8_t csum_hdr(struct gpib_hdr *hdr)
{
   uint32_t i;
   uint8_t csum;
   uint8_t *buf = (uint8_t *)&hdr;

   csum = buf[0];

   for(i = 2; i < hdr->len + sizeof(struct gpib_hdr) - 2; i++)
   csum += buf[i];

   return csum;
}

__attribute__ ((section (".text.crt")))
void _start(struct gpib_hdr *hdr)
{
  struct gpib_args *args = (void *)hdr;
  unsigned long *ram;
  int ret;

  if (_first_run == 0x12c0ffee) for (ram=_sbss; ram<_ebss; ram++) *ram = 0;
  _first_run = 0;

  ret = command(args->cmd->arg0, args->cmd->data, hdr->len-16);
  hdr->len = ret >= 0 ? ret+16 : 16;
  hdr->cmd = ret >= 0 ? '=' : '-';
  hdr->csum = csum_hdr(hdr);
}
